package it.imolinfo.cgil.util;

import java.io.StringReader;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;

import javax.xml.transform.stream.StreamSource;
import it.imolinfo.cgil.exception.ComponentXmlRpcException;

/**
 *
 * @author <a href="mailto:gvaleri@imolinfo.it">Giancarlo Valeri</a>
 */
public class UtilCgil {

    /**
     * 
     * 
     * @param xmlSource
     * @param clazz
     * @param pathPackage
     * @return
     * @throws it.imolinfo.cgil.exception.ComponentXmlRpcException
     */
    public static Object xmlSourceToObject(String xmlSource, Class clazz,
                                           String namespace) 
                                           throws ComponentXmlRpcException {

        JAXBContext jaxbContext = null;
        Unmarshaller unmarshaller = null;
        JAXBElement element = null;
        StreamSource source = null;

        // add namespace
        xmlSource = addNamespace(xmlSource, namespace);
        
//        log.debug("**********************************************************");
//        log.debug(xmlSource);
//        log.debug("**********************************************************");
        
        try {

            jaxbContext = JAXBContext.newInstance(clazz.getPackage().getName());
            //log.debug(">>>> newInstance");
            unmarshaller = jaxbContext.createUnmarshaller();
            //log.debug(">>>> createUnmarshaller");
            source = new StreamSource(new StringReader(xmlSource));
            element = (JAXBElement) unmarshaller.unmarshal(source, clazz);

        } catch (JAXBException ex) {
            String msg = "Errore - JAXBException";
            throw new ComponentXmlRpcException(msg, ex);
        } catch (Exception ex) {
            String msg = "Errore Generico";
            throw new ComponentXmlRpcException(msg, ex);
        }

        
        return element.getValue();

    }
        
    /**
     * 
     * 
     * @param xmlSource
     * @param pathPackage
     * @return
     * @throws it.imolinfo.cgil.exception.ComponentXmlRpcException
     */
    public static String addNamespace(String xmlSource, String namespace) 
                                                throws ComponentXmlRpcException{
        
        String result = null;
        String tagRoot = "<REPORT ";
        
        int index = xmlSource.indexOf(tagRoot);
        if (index == -1){
            String msg = "Impossibile trovare il tag radice [" + tagRoot + "]";
            throw new ComponentXmlRpcException(msg);
        }
        index = index + tagRoot.length();
        //log.debug("Index: "+index);
        
        // add before tagRoot
        result = (xmlSource.substring(0, index));
        // add namespace
        //result = result + "xmlns='http://" + invertString(pathPackage) + "'";
        result = result + "xmlns='" + namespace + "'";
        //add last tagRoot
        result = result + " " + xmlSource.substring(index);
        
        //log.debug("NameSpace aggiunto: "+result);
        return result;
    }
            

}   
